@ECHO OFF
::    ASCI2ISO.BAT converts ASCII characters to HTML character entities
::  By: (c) John Paul Jones, v1.00, Nicholas Owen Society
::    At: 16:48:10.20 Mon 10/28/2002
:: Use: ASCI2ISO InFile.TXT 
:: Requires: QBASIC.EXE, EDIT.COM in system path
  :: : : : : : : : : : : : : : : : : : : : : : : : : : : : : ::
  :: Some character entities are part of the HTML 2.0 and up ::
  :: standards and will work with almost any browser; others ::
  :: will only work with newer browsers.  Many characters in ::
  :: the ASCII extended set have no ISO equivalent and can't ::
  :: be translated into HTML using either name  or numerical ::
  :: entities.  So, where possible, a name entity is used to ::
  :: convert the ASCII character, which is preferable to use ::
  :: of numerical entities; numerical ones may be translated ::
  :: differently in different browsers.  Where possible, the ::
  :: ASCII character is translated using HTML 2.00 entities, ::
  :: but if not possible, extended HTML name entity is used. ::
  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IF [%1]==[] GOTO Asci2Hlp
IF NOT EXIST %1 ECHO File %1 not found.
IF NOT EXIST %1 GOTO xAsci2
FOR %%v IN (. %path%) DO IF EXIST %%v\QBASIC.EXE GOTO Asci2Go
ECHO QBASIC.EXE not found in system path or current directory
GOTO xAsci2
:Asci2Go
TYPE %1 > ASCI2ISO.TMP
> Q.BAS ECHO DIM LineOfText AS STRING 
>>Q.BAS ECHO DIM zCharacter AS STRING  ' character anayzed
>>Q.BAS ECHO DIM LineNumber AS INTEGER ' where in the file
>>Q.BAS ECHO DIM AtPosition AS INTEGER ' Where in the line of text
>>Q.BAS ECHO PRINT "ASCI2ISO v1.00(DOS) (c) John Paul Jones"
>>Q.BAS ECHO   OPEN "%1" FOR INPUT AS #1
>>Q.BAS ECHO   OPEN "ASCI2ISO.TMP" FOR OUTPUT AS #2
>>Q.BAS ECHO   LineNumber = 0
>>Q.BAS ECHO   DO UNTIL EOF(1) 
>>Q.BAS ECHO     REM CLS
>>Q.BAS ECHO     LINE INPUT #1, LineOfText
>>Q.BAS ECHO     LineNumber = LineNumber + 1
>>Q.BAS ECHO       REM PRINT "Line: " + STR$(LineNumber) + " " + LineOfText
>>Q.BAS ECHO     zCharacter = "" : Bld$ = ""
>>Q.BAS ECHO     FOR i = 1 TO LEN(LineOfText)
>>Q.BAS ECHO       zCharacter = MID$(LineOfText, i, 1)
>>Q.BAS ECHO       REM PRINT "Char: " + STR$(i) + " " + zCharacter
>>Q.BAS ECHO       SELECT CASE zCharacter
>>Q.BAS ECHO       CASE ">" ' Greater than
>>Q.BAS ECHO          zCharacter = "&gt;"
>>Q.BAS ECHO       CASE "<" ' Less than symbol
>>Q.BAS ECHO          zCharacter = "&lt;"
>>Q.BAS ECHO       CASE "&" ' Ampersand
>>Q.BAS ECHO          zCharacter = "&amp;"
>>Q.BAS ECHO       CASE "" ' Inverted exclamation point
>>Q.BAS ECHO          zCharacter = "&iexcl;" 
>>Q.BAS ECHO       CASE "" ' Fraction one-half
>>Q.BAS ECHO          zCharacter = "&frac12;" ' 4.0 
>>Q.BAS ECHO       CASE "" ' Fraction one-fourth
>>Q.BAS ECHO          zCharacter = "&frac14;" ' 4.0
>>Q.BAS ECHO       CASE "" ' Left angle quote
>>Q.BAS ECHO          zCharacter = "&laquo;"
>>Q.BAS ECHO       CASE "" ' Right angle quote
>>Q.BAS ECHO          zCharacter = "&raquo;"
>>Q.BAS ECHO       CASE "" ' Yen symbol
>>Q.BAS ECHO          zCharacter = "&yen;"
>>Q.BAS ECHO       CASE "" ' Pound symbol
>>Q.BAS ECHO          zCharacter = "&pound;"
>>Q.BAS ECHO       CASE "" ' Degree sign
>>Q.BAS ECHO          zCharacter = "&deg;"
>>Q.BAS ECHO       CASE "" ' Inverted question mark
>>Q.BAS ECHO          zCharacter = "&iquest;"
>>Q.BAS ECHO       CASE "" ' Plus or minus sign
>>Q.BAS ECHO          zCharacter = "&plusmn;"
>>Q.BAS ECHO       CASE "" ' Paragraph sign
>>Q.BAS ECHO          zCharacter = "&para;"
>>Q.BAS ECHO       CASE "" ' Section sign
>>Q.BAS ECHO          zCharacter = "&sect;"
>>Q.BAS ECHO       CASE "" ' Masculine ordinal
>>Q.BAS ECHO          zCharacter = "&ordm;"
>>Q.BAS ECHO       CASE "" ' Feminine ordinal
>>Q.BAS ECHO          zCharacter = "&ordf;"
>>Q.BAS ECHO       CASE "" ' Small o slash
>>Q.BAS ECHO          zCharacter = "&oslash;" 
>>Q.BAS ECHO       CASE "" ' division sign
>>Q.BAS ECHO          zCharacter = "&divide;"
>>Q.BAS ECHO       CASE "" ' 2 superscript
>>Q.BAS ECHO          zCharacter = "&sup2;"
>>Q.BAS ECHO       CASE "" ' cent sign
>>Q.BAS ECHO          zCharacter = "&cent;"
>>Q.BAS ECHO       CASE "" ' small a, acute accent
>>Q.BAS ECHO          zCharacter = "&aacute;"
>>Q.BAS ECHO       CASE "" ' small a, grave accent
>>Q.BAS ECHO          zCharacter = "&agrave;"
>>Q.BAS ECHO       CASE "" ' small a, circumflex accent
>>Q.BAS ECHO          zCharacter = "&acirc;"
>>Q.BAS ECHO       CASE "" ' small a, umlaut
>>Q.BAS ECHO          zCharacter = "&auml;"
>>Q.BAS ECHO       CASE "" ' small a, ring
>>Q.BAS ECHO          zCharacter = "&aring;"
>>Q.BAS ECHO       CASE "" ' small e, circumflex accent
>>Q.BAS ECHO          zCharacter = "&ecirc;"
>>Q.BAS ECHO       CASE "" ' small e, umlaut
>>Q.BAS ECHO          zCharacter = "&euml;"
>>Q.BAS ECHO       CASE "" ' small e, grave accent
>>Q.BAS ECHO          zCharacter = "&egrave;"
>>Q.BAS ECHO       CASE "" ' small e, acute accent
>>Q.BAS ECHO          zCharacter = "&eacute;"
>>Q.BAS ECHO       CASE "" ' small i, acute accent
>>Q.BAS ECHO          zCharacter = "&iacute;"
>>Q.BAS ECHO       CASE "" ' small i, grave accent
>>Q.BAS ECHO          zCharacter = "&igrave;"
>>Q.BAS ECHO       CASE "" ' small i, umlaut
>>Q.BAS ECHO          zCharacter = "&iuml;"
>>Q.BAS ECHO       CASE "" ' circumflex accent
>>Q.BAS ECHO          zCharacter = "&icirc;"
>>Q.BAS ECHO       CASE "" ' small o, grave accent
>>Q.BAS ECHO          zCharacter = "&ograve;"
>>Q.BAS ECHO       CASE "" ' small o, acute accent
>>Q.BAS ECHO          zCharacter = "&oacute;"
>>Q.BAS ECHO       CASE "" ' small o, circumflex
>>Q.BAS ECHO          zCharacter = "&ocirc;"
>>Q.BAS ECHO       CASE "" ' small o, umlaut
>>Q.BAS ECHO          zCharacter = "&ouml;"
>>Q.BAS ECHO       CASE "" ' capital A, umlaut
>>Q.BAS ECHO          zCharacter = "&Auml;"
>>Q.BAS ECHO       CASE "" ' capital A, ring
>>Q.BAS ECHO          zCharacter = "&Aring;"
>>Q.BAS ECHO       CASE "" ' capital E, acute accent
>>Q.BAS ECHO          zCharacter = "&Euml;"
>>Q.BAS ECHO       CASE "" ' capital O, umlaut
>>Q.BAS ECHO          zCharacter = "&Ouml;"
>>Q.BAS ECHO       CASE "" ' capital U, umlaut
>>Q.BAS ECHO          zCharacter = "&Uuml;"
>>Q.BAS ECHO       CASE "" ' small y, umlaut
>>Q.BAS ECHO          zCharacter = "&yuml;"
>>Q.BAS ECHO       CASE "" ' capital N, tilde
>>Q.BAS ECHO          zCharacter = "&Ntilde;"
>>Q.BAS ECHO       CASE "" ' small n, tilde
>>Q.BAS ECHO          zCharacter = "&ntilde;"
>>Q.BAS ECHO       CASE "" ' capital cedilla
>>Q.BAS ECHO          zCharacter = "&Ccedil;"
>>Q.BAS ECHO       CASE "" ' small c, cedilla
>>Q.BAS ECHO          zCharacter = "&ccedil;"
>>Q.BAS ECHO       CASE "" ' Greek small mu, micron
>>Q.BAS ECHO          zCharacter = "&micro;"
>>Q.BAS ECHO       CASE "" ' small u, grave accent
>>Q.BAS ECHO          zCharacter = "&ugrave;"
>>Q.BAS ECHO       CASE "" ' small u, acute accent
>>Q.BAS ECHO          zCharacter = "&uacute;"
>>Q.BAS ECHO       CASE "" ' small u, umlaut
>>Q.BAS ECHO          zCharacter = "&uuml;"
>>Q.BAS ECHO       CASE "" ' small u, circumflex accent
>>Q.BAS ECHO          zCharacter = "&ucirc;"
  : Greek characters
>>Q.BAS ECHO       CASE "" ' Greek small omega     ' 4.0 Extended HTML
>>Q.BAS ECHO          zCharacter = "&Omega;"
>>Q.BAS ECHO       CASE "" ' Greek small beta  ?   ' 4.0 Extended HTML
>>Q.BAS ECHO          zCharacter = "&beta;"
>>Q.BAS ECHO       CASE "" ' Greek small theta
>>Q.BAS ECHO          zCharacter = "&theta;"
>>Q.BAS ECHO       CASE "" ' Greek small alpha
>>Q.BAS ECHO          zCharacter = "&alpha;"
>>Q.BAS ECHO       CASE "" ' Greek small delta
>>Q.BAS ECHO          zCharacter = "&delta;"
>>Q.BAS ECHO       CASE "" ' Greek small gamma
>>Q.BAS ECHO          zCharacter = "&gamma;"
>>Q.BAS ECHO       CASE "" ' Greek capital gamma
>>Q.BAS ECHO          zCharacter = "&Gamma;"
>>Q.BAS ECHO       CASE "" ' Greek small sigma
>>Q.BAS ECHO          zCharacter = "&sigma;"
>>Q.BAS ECHO       CASE "" ' Greek epsilon
>>Q.BAS ECHO          zCharacter = "&epsilon;"
>>Q.BAS ECHO       CASE "" ' Greek phi
>>Q.BAS ECHO          zCharacter = "&phi;"
>>Q.BAS ECHO       CASE "" ' Greek pi
>>Q.BAS ECHO          zCharacter = "&pi;"
>>Q.BAS ECHO       CASE "" ' Greek small omega ? or infinity?
>>Q.BAS ECHO          zCharacter = "&omega;"
  : Mathematical
>>Q.BAS ECHO       CASE "" ' Intersection, cap
>>Q.BAS ECHO          zCharacter = "&cap;"    ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Identical to
>>Q.BAS ECHO          zCharacter = "&equiv;"  ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Square root, radical sign
>>Q.BAS ECHO          zCharacter = "&radic;"  ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE ""
>>Q.BAS ECHO          zCharacter = "&sum;"    ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE ""
>>Q.BAS ECHO          zCharacter = "&le;"     ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' 
>>Q.BAS ECHO          zCharacter = "&ge;"     ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' almost equal to, asymptotic
>>Q.BAS ECHO          zCharacter = "&asymp;"  ' 4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Dot operator
>>Q.BAS ECHO          zCharacter = "&sdot;"    '4.0 Extended HTML
  : Miscellaneous
>>Q.BAS ECHO       CASE "" ' Up arrow
>>Q.BAS ECHO          zCharacter = "&uarr;"     '4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Down arrow
>>Q.BAS ECHO          zCharacter = "&darr;"
>>Q.BAS ECHO       CASE "" ' Small f with hook
>>Q.BAS ECHO          zCharacter = "&fnof;"    '4.0 Extended HTML 
>>Q.BAS ECHO       CASE "" ' Black heart suit 
>>Q.BAS ECHO          zCharacter = "&hearts;"  '4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Black spade suit 
>>Q.BAS ECHO          zCharacter = "&spades;"  '4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Black club suit  
>>Q.BAS ECHO          zCharacter = "&clubs;"   '4.0 Extended HTML
>>Q.BAS ECHO       CASE "" ' Black diamonds   
>>Q.BAS ECHO          zCharacter = "&diams;"   '4.0 Extended HTML
>>Q.BAS ECHO       END SELECT
>>Q.BAS ECHO       Bld$ = Bld$ + zCharacter
>>Q.BAS ECHO     REM   PRINT Bld$
>>Q.BAS ECHO     NEXT i
>>Q.BAS ECHO     PRINT #2, Bld$
>>Q.BAS ECHO     REM PRINT Bld$
>>Q.BAS ECHO   LOOP
>>Q.BAS ECHO SYSTEM
QBASIC /RUN Q.BAS
IF EXIST Q.BAS DEL Q.BAS
REM IF EXIST ASCI2ISO.TMP TYPE ASCI2ISO.TMP > %1
REM IF EXIST ASCI2ISO.TMP DEL ASCI2ISO.TMP
GOTO xAsci2
:Asci2Hlp
@set isp=
@FOR %%v IN (%path% .) DO IF EXIST %%v\%0.BAT SET isp=%%v
@FIND "::" %isp%\%0.BAT|FIND /V "0.BAT"|FIND /V "---"
@IF NOT %clu%!==! ECHO   %clu%
ECHO.
:xAsci2
REM  ******************************************************************
REM                                ASCII Chart
REM   0                                                           
REM   20                                      !  "  #  $  %  &  '  (         
REM   40   )  *  +  ,  -  .  /  0  1  2    3  4  5  6  7  8  9  :  ;  >          
REM   60   =  >  ?  @  A  B  C  D  E  F    G  H  I  J  K  L  M  N  O  P          
REM   80   Q  R  S  T  U  V  W  X  Y  Z    [  \  ]  ^  _  `  a  b  c  d          
REM  100   e  f  g  h  i  j  k  l  m  n    o  p  q  r  s  t  u  v  w  x          
REM  120   y  z  {  |  }  ~                                         
REM  140                                                       
REM  160                                   
REM  180
REM  200
REM  220                                              
REM  240                                                                
REM
REM  ******* The ASCII characters above will translate into HTML ******
REM  if the browser supports exetended HTML entities;  otherwise, most,
REM  but not all, will translate into HTML.   Note that none of the box
REM  drawing characters will convert. 
